
--------------------------------------------------------------------------------
-- \fc      string rcpGetSendFileString()
--
--          MUST BE FILLED BY FOR THE ACTIVITY.
--
-- \brief   Returns the message string, which should send to the consist.
--
-- \return  the message string, which should send to the consist.
--------------------------------------------------------------------------------
function rcpGetSendString()

	local tmp = {};
	tmp[0] = "6686 TrainTeamBerlin/"	-- to set up the root directory
	-- to opt. initialize and play the given file.
	signalID = Call( "GetId" );
	tmp[1] = "6687 TTB-Tutorial/TTB_TUT_Test 0 " .. signalID;	
	return tmp;
   
end

-- INITIALIZATION FUNCTION
function Initialise()

	-- Signal Message Constants
	RESET_SIGNAL_STATE = 	0;
	JUNCTION_STATE_CHANGE = 2;
	SIGNAL_BLOCKED = 		12;
	SIGNAL_CLEARED = 		13;
	
	-- 2D Map State Constants
	CLEAR =     0;
	BLOCKED =   2;
	
	-- Initialize Global Variables
	gConnectedLink = -1;
	gInitialised = false;
	
	-- Tells the game to do an update tick once the route finished loading.
	Call("BeginUpdate");

end

-- UPDATE FUNCTION
function Update(time)

	gInitialised = true;
	
	-- Check the junction state.
	OnJunctionStateChange(0, "", 1, 0);
	Call("EndUpdate");
end

-- JUNCTION STATE CHANGE FUNCTION
function OnJunctionStateChange(junction_state, parameter, direction, linkIndex)

	-- Check to see if the track is still connected.
	gConnectedLink = Call("GetConnectedLink", "", 1, 0);
	
	if gConnectedLink == -1 then
	    Call("Set2DMapSignalState", BLOCKED);
	elseif gConnectedLink == 1 then
	    Call("Set2DMapSignalState", CLEAR);
	end
	
end

-- ON SIGNAL MESSAGE FUNCTION
function OnSignalMessage(message, parameter, direction, linkIndex)

	-- Do not forward "Reset Signal State".
	if message == RESET_SIGNAL_STATE then
	    Initialise();

	-- This message let us know, that the junctions are changing.
	elseif message == JUNCTION_STATE_CHANGE then
	
	    -- Act only for link 0.
	    if linkIndex == 0 and parameter == "0" then
	    
	        -- Call the junction state change function and pass the message.
	        OnJunctionStateChange(0, "", 1, 0);
			Call("SendSignalMessage", message, parameter, -direction, 1, 0);
	
	    end
	
	-- Other messages should be forwarded.
	else
	
	    -- Forward the message.
	    Call("SendSignalMessage", message, parameter, -direction, 1, linkIndex);
	
	end

end

-- ON CONSIST PASS FUNCTION
function OnConsistPass(prevFrontDist, prevBackDist, frontDist, backDist, linkIndex)

	-- Send the message if prevFrontDist < 0 and frontDist < 0.
	if 	(prevFrontDist < 0.0 and frontDist >= 0.0) or
		(prevFrontDist > 0.0 and frontDist <= 0.0) then
		
		local RCP_SOUND_MESSAGE = 15;
		local tmpMsgs = rcpGetSendString();
		
		if(tmpMsgs[0] ~= nil) then 
			Call("SendConsistMessage", RCP_SOUND_MESSAGE, tmpMsgs[0]); 
		end
	   	 Call("SendConsistMessage", RCP_SOUND_MESSAGE, tmpMsgs[1]);
		

	end

end